//   ( ,   )
// Proteus 2012 lawnmower-man@mail.ru
//   Insert Remove Clean     ( InsertRoot Join  )

#include<stdlib.h>


class RandTreeLite{
	struct Node{
		int v;
		Node *p1,*p2;
		Node(int v):v(v),p1(0),p2(0) {}
	};
	int count;
	Node *root;
	Node *Insert(Node*,int,int);
	Node *InsertRoot(Node*,int);
	Node *Remove(Node*,int);
	Node *Join(Node*,Node*);
	void Clear(Node*);
public:
	RandTreeLite():root(0),count(0) {}
	~RandTreeLite() {Clear(root);}
	bool Find(int);
	int  Size() {return count;}
	void Insert(int v) {root=Insert(root,v,++count);}
	void Remove(int v) {root=Remove(root,v);}
};

void RandTreeLite::Clear(Node *node)
{
	if(node) Clear(node->p1),Clear(node->p2);
	delete node;
}

bool RandTreeLite::Find(int v)
{
	for(Node *node=root; node;) {
		if(node->v==v) return true;
		node=(v<node->v)?node->p1:node->p2;
	}
	return false;
}


RandTreeLite::Node *RandTreeLite::Insert(Node *node,int v,int count)
{
	if(!node || rand()%count==0) return InsertRoot(node,v);
	count=count/2+1;
	if(v<node->v) node->p1=Insert(node->p1,v,count); 
	else node->p2=Insert(node->p2,v,count); 
	return node;
}


RandTreeLite::Node *RandTreeLite::InsertRoot(Node *node, int v)
{
	Node *p;
	if(!node) return new Node(v); 
	if(v<node->v) {
		p=InsertRoot(node->p1,v); 
		node->p1=p->p2,p->p2=node; 
	} else {
		p=InsertRoot(node->p2,v);
		node->p2=p->p1,p->p1=node;
	}
	return p;
}


RandTreeLite::Node *RandTreeLite::Join(Node *p1,Node *p2)
{
	if(!p1) return p2;
	if(!p2) return p1;
	if(rand()&1) {
		p1->p2=Join(p1->p2,p2); 
		return p1; 
	} else {
		p2->p1=Join(p1,p2->p1); 
		return p2;
	}
	return 0;
}


RandTreeLite::Node *RandTreeLite::Remove(Node *node,int v)
{
	if(!node) return 0; 
	if(v<node->v) node->p1=Remove(node->p1,v); 
	else if(v>node->v) node->p2=Remove(node->p2,v); 
	else {
		Node *d=node;
		node=Join(node->p1,node->p2); 
		delete d;
		count--;
	}
	return node;
}



void main()
{
	int n;
	RandTreeLite tree;
	for(n=0; n<100000; n++) tree.Insert(rand());
	for(n=0; n<100000; n++) tree.Remove(rand());
	for(n=0; n<1000000; n++) {
		tree.Insert(rand());
		tree.Remove(rand());
	}
}







